## mingw-w64-tixi-3.3.0-4.src.tar.zst

=== bindings/CMakeLists.txt ===
add_subdirectory(matlab)
add_subdirectory(python)
add_subdirectory(cpp)

if (TIXI_ENABLE_FORTRAN)
  add_subdirectory(fortran03)
  add_subdirectory(fortran)
endif(TIXI_ENABLE_FORTRAN)

=== bindings/fortran/CMakeLists.txt ===
# TIXI Fortran interface
# @author: Martin Siggel

set(TIXI_F_SRC tixi77.c)
set(TIXI_F_HDR tixi77.h)

#find out the fortran compiler
include(CMakeDetermineFortranCompiler)

if(CMAKE_Fortran_COMPILER STREQUAL CMAKE_Fortran_COMPILER-NOTFOUND)
    message(STATUS "No Fortran Compiler found, please specify for which compiler the interface should be built")
else()
    if(${CMAKE_Fortran_COMPILER} MATCHES "gfortran")
        message(STATUS "Generating fortran interface for gfortran naming scheme.")
        add_definitions(-DGFORTRAN)
    elseif(${CMAKE_Fortran_COMPILER} MATCHES "g77")
        message(STATUS "Generating fortran interface for g77 naming scheme.")
        add_definitions(-DG77)
    elseif(${CMAKE_Fortran_COMPILER} MATCHES "f90_irix")
        message(STATUS "Generating fortran interface for f90/irix naming scheme.")
        add_definitions(-DF90_IRIX)
    elseif(${CMAKE_Fortran_COMPILER} MATCHES "f90")
        message(STATUS "Generating fortran interface for f90 naming scheme.")
        add_definitions(-DGFORTRAN)
    elseif(${CMAKE_Fortran_COMPILER} MATCHES "ifort")
        message(STATUS "Generating fortran interface for intel-fortran (ifort) naming scheme.")
        if (WIN32)
            add_definitions(-DIFORT_WIN32)
        else()
            add_definitions(-DIFORT_UNIX)
        endif()
    endif()

    if (C_COMPILER_HAS_NO_DEPRECATED_DECL_OPTION)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-deprecated-declarations")
    endif()

    add_library(${TIXI_LIB_NAME}-f90 STATIC ${TIXI_F_SRC} ${TIXI_F_HDR})
    target_link_libraries(${TIXI_LIB_NAME}-f90 ${TIXI_LIB_NAME})
    set_target_properties(${TIXI_LIB_NAME}-f90 PROPERTIES VERSION ${TIXI_VERSION})

    install (TARGETS ${TIXI_LIB_NAME}-f90
        DESTINATION ${CMAKE_INSTALL_LIBDIR}
        COMPONENT interfaces)
    
    install (FILES tixi77.h 
        DESTINATION ${CMAKE_INSTALL_INCLUDE_DIR}
        COMPONENT interfaces)
    
    install(TARGETS ${TIXI_LIB_NAME}-f90 EXPORT ${TIXI_LIB_NAME}-f90-targets
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        RUNTIME DESTINATION bin
    )

    install(EXPORT ${TIXI_LIB_NAME}-f90-targets
        DESTINATION ${CONFIG_INSTALL_DIR}
    )

endif()

=== examples/fortran77/CMakeLists.txt ===
# only build, if fortran compiler was found before
if(NOT CMAKE_Fortran_COMPILER STREQUAL CMAKE_Fortran_COMPILER-NOTFOUND AND CMAKE_Fortran_COMPILER)
    enable_language(Fortran)

    # copy xml files
    file(GLOB_RECURSE inputdata ${PROJECT_SOURCE_DIR}/examples/Demo/*.xml)
    file(COPY ${inputdata} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

    add_executable(testarrayf77 testarrayf77.f)
    target_link_libraries(testarrayf77 ${TIXI_LIB_NAME}-f90 ${TIXI_LIB_NAME})

    add_executable(testvectorf77 testvectorf77.f)
    target_link_libraries(testvectorf77 ${TIXI_LIB_NAME}-f90 ${TIXI_LIB_NAME})

    add_executable(tixi_fortran_examples tixi_fortran_examples.f)
    target_link_libraries(tixi_fortran_examples ${TIXI_LIB_NAME}-f90 ${TIXI_LIB_NAME})


endif()

=== PKGBUILD ===
# Contributor: Melven Roehrig-Zoellner <Melven.Roehrig-Zoellner@DLR.de>

_realname=tixi
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=3.3.0
pkgrel=4
pkgdesc="TiXI is a fast and simple XML interface library (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://github.com/DLR-SC/tixi'
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-curl"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-libxslt")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-python")
conflicts=("${MINGW_PACKAGE_PREFIX}-tixi3")
replaces=("${MINGW_PACKAGE_PREFIX}-tixi3")
provides=("${MINGW_PACKAGE_PREFIX}-tixi3")
source=("https://github.com/DLR-SC/tixi/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        0001-Dont-build-and-install-the-examples.patch
        0002-Fix-ctypes-DLL-loading-in-Python-3.8-new-policy.patch
        0003-fix-build-with-latest-libxml2.patch::https://github.com/DLR-SC/tixi/commit/732f6ad3.patch)
sha256sums=('988d79ccd53c815d382cff0c244c0bb8e393986377dfb45385792766adf6f6a9'
            'b3411df0057eef3b8fa4c56e432bf90938fedc0833d3cce9d9c66fbcb7101c42'
            '9ef13729efb68420f869e21259bce492ee4c66e624bbe5901abe296f56fafc6a'
            'a87bd7a4ea402bebb298065cd603aa7de291c39b96a2930c30011f88b3740d5f')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"
  patch -Np1 -i "${srcdir}/0001-Dont-build-and-install-the-examples.patch"
  patch -Np1 -i "${srcdir}/0002-Fix-ctypes-DLL-loading-in-Python-3.8-new-policy.patch"
  dos2unix "${srcdir}"/0003-fix-build-with-latest-libxml2.patch
  patch -Np1 -i "${srcdir}/0003-fix-build-with-latest-libxml2.patch"
}


build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi
  
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
      -DTIXI_ENABLE_FORTRAN=ON \
      -DBUILD_SHARED_LIBS=ON \
      "${extra_config[@]}" \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}


package() {
  cd "${srcdir}"/build-${MSYSTEM}

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --build . --target install

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" \
    "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
